#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>

int main(void)
{
  int calu, tube[2];
  
  pipe(tube);

  if( fork() ) /* pre */
    {
      close(STDOUT_FILENO); dup(tube[1]); 
      close(tube[0]); close(tube[1]);
      
      while( (calu = getchar()) != '.')
	{
	  if ( calu >= 'a' && calu <= 'z')
	    calu -= 'a' - 'A'; 
	  printf("%c",calu);
	}
      fflush(stdout);
      close(STDOUT_FILENO);
      wait(NULL);
      exit(EXIT_SUCCESS);
    }
  else /* fils */
    {
      close(STDIN_FILENO); dup(tube[0]); 
      close(tube[0]); close(tube[1]);

      while( (calu = getchar()) != EOF)
	printf("[fils] : >%c<\n", calu);

      printf("Fin du fils\n"); 
      exit(EXIT_SUCCESS);
    }
}

