#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <assert.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

int main(void)
{
  int readfd, writefd;

  if(mkfifo("le_tube",0777) == -1 )
    {
      perror("mkfifo"); exit(0);
    }

  if (fork() == 0)
    {
      writefd = open("le_tube",O_WRONLY);assert(writefd != -1);
      
      close(STDOUT_FILENO);
      dup(writefd);
      close(writefd);
      execlp("ls","ls","-l",NULL);
      perror("exec ls"); /* Jaimais atteint sauf erreur */
    }
  else
    {
      readfd = open("le_tube",O_RDONLY); assert(readfd != -1);
      close(STDIN_FILENO);
      dup(readfd);
      close(readfd);
      execlp("wc","WOdcount","-l",NULL);
      perror("exec wc"); /* jaimais atteint sauf erreur */
    }
  exit(EXIT_FAILURE); /* Jaimais atteint sauf erreur */
}

